/*
 *      os2.h
 *
 *      Copyright (c) 1994 by Borland International
 *      All Rights Reserved.
 *
 */

#include "newexe.h"         // The generic borland New Exe header file

typedef struct {
  bits16	sector_offset;		/* Offset to logical sector	*/
  bits16	segment_length; 	/* Size in bytes of segment	*/
  unsigned	segment_type  : 3;	/* Segment type identification	*/
  unsigned	iterated      : 1;	/* Segment is iterated		*/
  unsigned	movable       : 1;	/* Segment is movable		*/
  unsigned	pure	      : 1;	/* Segment is sharable		*/
  unsigned	preload       : 1;	/* Segment is not demand loaded */
  unsigned	read_only     : 1;	/* Segment is read-only 	*/
  unsigned	reloc_info    : 1;	/* Segment has reloc info	*/
  unsigned	conforming    : 1;	/* Segment is conforming (used to be debug info) */
  unsigned  dpl_bits      : 2;  /* 80286 DPL bits           */
  unsigned  discardable   : 1;  /* Discardable flag.        */
  unsigned  discardPrior  : 3;  /* Segment Discard Priority */
  bits16  alloc_size;     /* Segment allocation size      */
  } SEGMENT_RECORD;


typedef enum {				/* Segment type constants	*/
  CODE		= 0x0000,		/* Code segment type		*/
  DATA		= 0x0001,		/* Data segment type		*/
  } SEGMENT_TYPES;

typedef struct
{
        unsigned char   segNumber;
        unsigned char   reserved;
        bits16    ordinal;
}       INTERNAL_REFERENCE_RELOCATION;

typedef struct
{
        bits16    index;
        bits16    ordinal;
}       IMPORTED_ORDINAL_RELOCATION;

typedef struct
{
        bits16    index;
        bits16    nameOff;
}       IMPORTED_NAME_RELOCATION;

typedef struct
{
        unsigned char   type;
        unsigned char   entryType;
        bits16    off;
        union
        {
                INTERNAL_REFERENCE_RELOCATION   r;
                IMPORTED_ORDINAL_RELOCATION     o;
                IMPORTED_NAME_RELOCATION        n;
        } i;
}       RELOCATION_RECORD;

typedef struct {			/* Resource table record	*/
  bits16	type_id;		/* Type ID or string offset	*/
  bits16	resource_count; 	/* # of resources to this type	*/
  bits32 reserved1;		/* Reserved DD space		*/
  } RESOURCE_HEADER;

typedef struct
{
        bits16 offset;
        bits16 length;
        unsigned reserved1:4;
        unsigned movable:1;
        unsigned pure:1;
        unsigned preload:1;
        unsigned reserved2:5;
        unsigned discardPriority:4;
        bits16 resourceNumber;
        unsigned char reserved3[4];
}       RESOURCE_ENTRY;

typedef enum {                          /* Indicator Types              */
  UNUSED	= 0x00, 		/* Segment is unused		*/
  MOVABLE	= 0xff			/* Segment is movable		*/
  } INDICATORS;


typedef struct {			/* Basic entry record		*/
  unsigned char eflags; 		/* Export and Share Flags	*/
  bits16	int3f;			/* INT 03fh  (0xcd 0x3f)	*/
  unsigned char seg_number;		/* Segment number		*/
  bits16	offset; 		/* Segment offset		*/
  } MOV_ENTRY;

typedef struct {			/* Basic entry record		*/
  unsigned char eflags; 		/* Export and Share Flags	*/
  bits16	offset; 		/* Segment offset		*/
  } FIX_ENTRY;

